(*  Title: 	LK/set/nonthinned
    Author: 	Lawrence C Paulson, Cambridge University Computer Laboratory
    Copyright   1988  University of Cambridge

OBSOLETE
 *)

val subset_left = prove_goal Set_Rule.thy
    "[| $H, $G, A<=B |- $E, c:A |] ==> [| $H, c:B, $G, A<=B |- $E |] ==>  \
\    [| $H, A <= B, $G |- $E |]"
 (fn asms=>
  [ (duplicate_tac 1),
    (REPEAT (resolve_tac (asms @ [subset_left_thin]) 1)) ]);


val eqext_left = prove_goal Set_Rule.thy
    "[| $H, $G, A=B |- $E, c:A, c:B |] ==>  \
\    [| $H, c:B, c:A, $G, A=B |- $E |] ==>  \
\    [| $H, A=B, $G |- $E |]"
 (fn asms=>
  [ (duplicate_tac 1),
    (REPEAT (resolve_tac (asms @ [eqext_left_thin]) 1)) ]);


val Replace_right = prove_goal Set_Rule.thy
    "[| $H |- $E, a:B, $F, c: Replace(f,B) |] ==>  \
\    [| $H |- $E, c=f(a), $F, c: Replace(f,B) |] ==> \
\    [| $H |- $E, c : Replace(f,B), $F |]"
 (fn asms=>
  [ (duplicate_tac 1),
    (REPEAT (resolve_tac (asms @ [Replace_right_thin]) 1)) ]);


val Inter_left = prove_goal Set_Rule.thy
    "[| $H, A:B, $G, A: Inter(C) |- $E |] ==> \
\    [| $H, $G, A: Inter(C) |- $E, B:C |] ==> \
\    [| $H, A: Inter(C), $G |- $E |]"
 (fn asms=>
  [ (duplicate_tac 1),
    (REPEAT (resolve_tac (asms @ [Inter_left_thin]) 1)) ]);


val Union_right = prove_goal Set_Rule.thy
    "[| $H |- $E, A:B, $F, A: Union(C) |] ==> \
\    [| $H |- $E, B:C, $F, A: Union(C) |] ==> \
\    [| $H |- $E, A : Union(C), $F |]"
 (fn asms=>
  [ (duplicate_tac 1),
    (REPEAT (resolve_tac (asms @ [Union_right_thin]) 1)) ]);


(* Equality-left by equality of members.  Ordinary and thinned.  c is new var.
    if  a=b   then   ALL x. a:x <-> b:x  *)
val eqmem_left = prove_goal Set_Rule.thy
    "[| $H, $G, a=b |- $E, a:c, b:c |] ==> \
\    [| $H, $G, a=b, b:c, a:c |- $E |] ==> \
\    [| $H, a=b, $G |- $E |]"
 (fn asms=>
  [ (duplicate_tac 1),
    (resolve_tac [eqmem_left_thin] 1),
    (REPEAT (resolve_tac asms 1)) ]);
